allocation <-
function (param1,output_mw, maxiter=5,minouter,maxouter,minprof=0,integ.solution="NO ",
 convergence=0.01)

{

#################################################################
#   RICHIAMO DELLA FUNZIONE DI BETHEL MODIFICATO                #
#################################################################


beth <- function (
           stratif, 
           errors, 
           minnumstrat=minprof,      #MODIFICATO PER L'ALLOCAZIONE MW
           maxiter=200, 
           maxiter1=25, 
           printa=TRUE, 
           epsilon=10^(-11)) 
# Begin body 
{
  {

# for 1 stage creation of param_alloc in the WS - with the parameters of the allocation (iteration, minimum n. of strata....)

  param_alloc<-as.data.frame(t(c(
                epsilon,
                minnumstrat, 
                maxiter, 
                maxiter1  ) ))
   names(param_alloc)=
   c(
     "p_epsilon",    
     "p_minnumstrat", 
     "p_maxiter", 
     "p_maxiter1" )

   }

#print(param_alloc)

        colnames(stratif) <- toupper(colnames(stratif)) #   if 2 stages already done...
        colnames(errors) <- toupper(colnames(errors))
       
 #--------------------------------------------------------------
        # Initialization of parameters. Attribution of initial values
        #------------------------------------------------------------
        # parametri che si definiscono per la convergenza       
        # parameter Epsilon - value for the convergence epsilon=10^(-11)
        # maxiter<-200  nro massimo di loop per chromy iter<maxiter
        # maxiter1<-25  nro massimo iterazione per ulteriore aggiustamento 
# allocazione casi n>N - si rendono censuarie

         
          iter1<-0  
          val=NULL
          m <- NULL
          s <- NULL
          cv=NULL                          
        
        #------------------------------
        # Initialization of parameters 
        #------------------------------

          nstrat=nrow(stratif)                
          nvar=ncol(errors)-1
          ndom=nrow(errors)

         param_alloc$nvar<-nvar
         param_alloc$ndom<-ndom
         param_alloc$nstrat<-nstrat

#assign("param_alloc",param_alloc,env=.GlobalEnv)

      
          varloop <- c(1:nvar)
          strloop <- c(1:nstrat)
          domloop <- c(1:ndom)
        
        #---------------------------------------------------------
        # Initial Data Structures - selection from input variables 
        #---------------------------------------------------------
        
        # means
          med   <-as.matrix(stratif[,names(stratif) %in% 
                            sapply(1:nvar, function(i) paste("M",i,sep=""))])
        
        # variances estimates 
          esse  <-as.matrix(stratif[,names(stratif) %in% 
                            sapply(1:nvar, function(i) paste("S",i,sep=""))])
        
        # domains 
          nom_dom <-sapply(1:ndom, function(i) paste("DOM",i,sep="")) 
          dom     <-as.vector(stratif[,names(stratif) %in% nom_dom])
        
        # populations
          N <- as.vector(stratif$N)
        
        # vectors cens and cost
          cens  <- as.vector(stratif$CENS) 
          cost  <- as.vector(stratif$COST)
            nocens=1-cens  
        
        # numbers of different domains of interest (numbers of modalities/categories 
        # for each type of domain)
          if (ndom ==1) (nvalues<-nlevels((as.factor(stratif$DOM1))))  
          if (ndom>1) {nvalues<-sapply(nom_dom, function(vari) 
                          {val<-c(val, nlevels(as.factor(dom[,vari])))})}
        #-------------------------------------------------
        #  Building means (m) and deviations matrices (s) 
        #  for different domains of interest
        #-------------------------------------------------
        
        #-------------------------------------------------
        # disjunctive matrix
        #-------------------------------------------------
                
         crea_disj=function(data,vars)
         {
           out=NULL
           sapply( vars, function(vari){ 
                col=as.factor(data[,vari]) 
                out<<- cbind(out, outer(col, levels(col), function(y,x) ifelse(y==x,1,0))) 
                })
                out
        }

        disj<-crea_disj(stratif,nom_dom)
             
        nc  <- ncol(disj)
        
        #  (m) and (s) 
        for(i in 1:nc) 
           { m <- cbind(m, disj[,i]*med )
             s <- cbind(s, disj[,i]*esse ) }
        
        #-------------------------------------------------------------
        # computation of the coefficients of variation CVs 
        # for different domains of interest
        #-------------------------------------------------------------
        for (k in domloop) 
         {cvx <- as.matrix( errors[k,names(errors) %in% 
                  sapply(1:nvar, function(i)   paste("CV",i,sep=""))])
             ndomvalues <- c(1:nvalues[k])      
             for (k1 in ndomvalues) { cv <- cbind(cv,cvx)  }    
         }
        #------------------------------------------------------------
        # New definition of initial values 
        #------------------------------------------------------------
          
  alfa2<-NULL
          
  nvar_orig<-nvar
        
          nvar <- ncol(cv)         # new numbers of variables 
          varloop <- c(1:nvar)   
        
          NTOT <- c(rep(0,nvar))
          CVfin <- c(rep(0,nvar))
          varfin <- c(rep(0,nvar))
          totm <- c(rep(0,nvar))  
        #------------------------------------------------------------
        # Calculation of aij - matrix of standardized precision units    
        #------------------------------------------------------------
         crea_a=function()
         {
                  numA <- (N**2)*(s**2)*nocens

                  denA1<-colSums(t(t(N*m)*c(cv)))^2 
                  denA2<-colSums(N*(s**2)*nocens)

                  denA<-denA1+denA2+epsilon 

                  a<-t(t(numA)/denA)                     
                return(a) 
         }

        #-----------------------------------------------------------
        # Computation of alfa's values - Chromy Algorithm Iteration 
        #-----------------------------------------------------------

         chromy=function(alfatot,diff,iter, alfa, alfanext, x)
         {
                  while ( diff > epsilon && iter<maxiter ) 
                  {
                          iter <- iter + 1

                          den1 =sqrt(rowSums(t( t(a)*c(alfa)) ))              
                          den2=sum(sqrt(rowSums(t(t(a*cost)*c(alfa)))))

                          x<-sqrt(cost)/(den1*den2+ epsilon)

                          alfatot <- sum( c(alfa)*(t(a)%*%x)**2 )   
                          alfanext <- c(alfa)*(t(a)%*%x)**2/alfatot           

                          diff <- max(abs(alfanext-alfa))
                          alfa <- alfanext  
                          alfa2 <<- alfanext    #For sensitivity
                }
        # Allocation vector
 
 
  if (integ.solution=="YES")
         { n <- ceiling(1 / x)}
  if (integ.solution=="NO ")
        {n <- (1 / x) }              ###ALLOCAZIONE MW PAOLO

        
             return(n)
        }

                
        a<-crea_a()
         n<-chromy(0,999,0,c(rep(1/nvar,nvar)), c(rep(0,nvar)), array(0.1,dim=c(nstrat,1)))
        
        # check n>N  
        contx<-sum(n>N) 
        cens[n>N]<-1
        nocens=1-cens
        
        #check n<minnumstr
        for (i in strloop) 
          { if (n[i] < minnumstrat) { n[i] <- min(minnumstrat, N[i])} }
        
        
        ####ITERATIONS###
        while (contx>0 && iter1<maxiter1)
        {
          iter1=iter1+1
#-----------------------------------------------------------
# Calculation of aij - matrix of standardized precision units    
# Computation of alfa's values - Chromy Algorithm Iteration 
#-----------------------------------------------------------    
          a<-crea_a()
          n<-chromy(0,999,0,c(rep(1/nvar,nvar)), c(rep(0,nvar)), array(0.1,dim=c(nstrat,1)))
        
          # check n>N  
          contx<-sum(n>N) 
          cens[n>N]<-1
          nocens=1-cens
        
        for (i in strloop) 
          { if (n[i] < minnumstrat) { n[i] <- min(minnumstrat, N[i])}}}
        
        #-------------------------
        #Definitive best allocation
        #-------------------------

        n=(nocens*n)+(cens*N)
        #-------------------------
#-----------------------------------------------------------
   
#output_beth<-list(cens=cens, nom_dom=nom_dom, dom=dom, med=med, n=n, Bethel_sample=Bethel_sample, Bethel_Report1=as.data.frame(df), Bethel_Report2=read.table ("Bethel_Report2.txt", header=TRUE))
output_beth<-list(cens=cens, sample.size=n)

#assign("output_beth",output_beth,env=.GlobalEnv)


return(n)


 
 # End body
}

####################################################
#FINE BETHEL MODIFICATO
####################################################


library(MASS)

param<-param1$meta
cc<-c(paste("M",1:param$domvar,sep=""))
 Y<- as.matrix(subset(param$STRATA,select=cc))

######################################################################
#######    macro beta_p   ############################################


##########################
##########################
####### OUTER LOOP #######
##########################
##########################

if (minouter==100)

{
   
      
hist_expected_cv   <- vector(mode="numeric")
hist_stat <- vector(mode="numeric")
hist_constraints <- vector(mode="numeric")


      c<-c(param$id,paste(param$MARG,1:param$nmarg,sep=""),param$pop, param$start_size)
      output<- subset(param1$namedata,select=c)


size_out100<- subset(output, select=param$start_size)    
colnames(size_out100)<-c("size_out100")
output<-cbind(output,size_out100)
      #output<-output [,-5] ###

}

if (minouter>100)
{
      output<-output_mw$output
      errors<-output_mw$errors
      output_prob <-output_mw$output_prob
      
      hist_constraints <-output_mw$hist_constraints
      hist_expected_cv <-output_mw$hist_expected_cv
      hist_stat        <-output_mw$hist_stat
}



for (out in minouter:maxouter){

probabil <- as.matrix(subset(output,select=paste("size_out",out,sep="")))

print(out)

zzzmatrix<-sweep(param1$modelmatrix,MARGIN=1,probabil,`*`) 
colnames(zzzmatrix)<-c(paste("z",1:param$dim_dom$MARGT,sep=""))

aweight<-(probabil/param$POP)*(param$POP-probabil)
bweight<-param$POP-probabil


#################  IML  ################# 

#######    /*creation inverse matrix of the beta*/    ######


aweight<-as.vector(aweight)
A=t(param1$modelmatrix) %*% (sweep(param1$modelmatrix,MARGIN=1,aweight,`*`))
INVA<-ginv(A)
#######   /*cretion matrix delta*zeta*weight*/   #########

bweight<-as.vector(bweight)
ZPROB<-(param1$modelmatrix * bweight)

#######    creation matrix second part of betas    #######
TZPROB<-t(ZPROB)
B<-TZPROB %*% Y            #ATTENZIONE MEMORIA  !!!!
BETA<- INVA %*% B          #ATTENZIONE MEMORIA  !!!!        
G<-param1$modelmatrix %*% BETA    #ATTENZIONE MEMORIA  !!!!
colnames(G)<-c(paste("g",1:(param$dim_dom$MARGT*param$vars),sep=""))


#######    fine macro beta_p   ##########################################

##############################         FINE IML         ################# 

##########################
##########################
####### INNER LOOP #######
##########################
##########################


cv_expected    <-matrix(,maxiter,3+param$domvar)  ###cv_eta
constraint     <-matrix(,maxiter,3+param$domvar)  ###cv poisson
stat           <-matrix (,maxiter,10)

colnames(cv_expected)<-c("out_iter","in_iter","sample",paste("cv_eta",1:param$domvar,sep=""))
colnames(constraint) <-c("out_iter","in_iter","sample", paste("cv",1:param$domvar,sep=""))
colnames(stat)       <-c("out_iter","in_iter","sample","difsample",
"n_pos","n_pos1","mean_difpos","median_difpos","q3_difpos","max_difpos")
 

#dim_cv_hist<-param$domvar*param$vars+15
dim_cv_hist<-param$domvar*2+15

cv_hist<-matrix(,maxiter,dim_cv_hist)
colnames(cv_hist)<-c("out_iter","in_iter","sum_difpos","camp","abs_difprob",
paste("cv_eta",1:param$domvar,sep=""),paste("cv",1:param$domvar,sep=""),
"n_pos","n_pos1","sum_cv_eta","rel_difpos","weight_difpos","mean_difpos",
"median_difpos","q1_difpos","q3_difpos","max_difpos")

b_fin<-vector(mode="numeric")

prob_1<-as.vector(probabil)


for (inn in 1:maxiter)

{

if (out==100 && inn==1)

{
peson<-as.vector((1/param$POP)*(param$POP-prob_1)*prob_1)

pesol<-2*(param$POP-prob_1)

sum_vp <-as.vector(apply((sweep(param1$matrixres,MARGIN=1,(param$POP**2/prob_1),`*`)),2,sum))
sum_v  <-as.vector(apply((sweep(param1$matrixres,MARGIN=1,param$POP,`*`)),2,sum))
sum_l  <-as.vector(apply((sweep((G*Y),MARGIN=1,pesol,`*`)),2,sum))
sum_n  <-as.vector(apply((sweep(G**2,MARGIN=1,peson,`*`)),2,sum))
sum_hh <-as.vector(apply((sweep(Y**2,MARGIN=1,(param$POP**2/prob_1),`*`)),2,sum))
sum_hhh<-as.vector(apply((sweep(Y**2,MARGIN=1,param$POP,`*`)),2,sum))
sum_h  <-as.vector(apply((sweep(Y,MARGIN=1,param$POP,`*`)),2,sum))

#####   eta variance: queste varianze devono essere confrontate con quelle di soglia  #####

var_eta<-param$fpc*(sum_hh-sum_hhh+sum_n-sum_l+(sum_vp-sum_v))
cv_eta=sqrt(var_eta)/sum_h 
cv_eta<-as.vector(cv_eta)

####   y variance nel campionamento bilanciato e creazione degli errori soglia per beth., relativi al bilanciato  ####

var_y=(param1$cvt_err)**2*((sum_h)**2) + param$fpc*(sum_l-sum_n)
colnames(var_y)<-c(paste("var_y",1:(param$domvar),sep=""))
for(j in 1:param$domvar)
 {
 if (-0.000001<var_y[,j]& var_y[,j]<0) {var_y[,j]<-0}
             }

cv=sqrt(var_y)/sum_h
colnames(cv)<-c(paste("CV",1:(param$domvar),sep=""))
for(j in 1:param$domvar)
 {
cv[,j][is.na(cv[,j])]<-0.01
            }
errors=as.data.frame(cv)
DOM="DOM1"
errors=cbind(errors,DOM)

   }
 
 
camp_prec<-sum(prob_1)     

#############CHROMY ALGORTITHM######

b=beth(stratif=param$STRATA, errors)
###################################
###################################
b_fin<-rbind(b_fin,b)

if (nrow(b_fin)>=2 && abs(sum(b_fin[nrow(b_fin)-1,])-sum( b_fin[nrow(b_fin),]))<convergence)
break;

prob_1=as.vector(b)

print(inn)
print (sum(b))

################
peson<-as.vector((1/param$POP)*(param$POP-prob_1)*prob_1)

pesol<-2*(param$POP-prob_1)

sum_vp <-as.vector(apply((sweep(param1$matrixres,MARGIN=1,(param$POP**2/prob_1),`*`)),2,sum))
sum_v  <-as.vector(apply((sweep(param1$matrixres,MARGIN=1,param$POP,`*`)),2,sum))
sum_l  <-as.vector(apply((sweep((G*Y),MARGIN=1,pesol,`*`)),2,sum))
sum_n  <-as.vector(apply((sweep(G**2,MARGIN=1,peson,`*`)),2,sum))
sum_hh <-as.vector(apply((sweep(Y**2,MARGIN=1,(param$POP**2/prob_1),`*`)),2,sum))
sum_hhh<-as.vector(apply((sweep(Y**2,MARGIN=1,param$POP,`*`)),2,sum))
sum_h  <-as.vector(apply((sweep(Y,MARGIN=1,param$POP,`*`)),2,sum))

camp<-sum(prob_1) 

#########     estraggo da err le variabili cvt      ######### 

#PARTE SPOSTATA ALL'INIZIO

#####   eta variance: queste varianze devono essere confrontate con quelle di soglia  #####

var_eta<-param$fpc*(sum_hh-sum_hhh+sum_n-sum_l+(sum_vp-sum_v))
cv_eta=sqrt(var_eta)/sum_h 
cv_eta<-as.vector(cv_eta)

####   y variance nel campionamento bilanciato e creazione degli errori soglia per beth., relativi al bilanciato  ####

var_y=(param1$cvt_err)**2*((sum_h)**2) + param$fpc*(sum_l-sum_n)
colnames(var_y)<-c(paste("var_y",1:(param$domvar),sep=""))
for(j in 1:param$domvar) {
if (-0.000001<var_y[,j]& var_y[,j]<0) {var_y[,j]<-0}
                   }

cv=sqrt(var_y)/sum_h
colnames(cv)<-c(paste("CV",1:(param$domvar),sep=""))
for(j in 1:param$domvar) {
cv[,j][is.na(cv[,j])]<-0.01
                   }
errors=as.data.frame(cv)
DOM="DOM1"
errors=cbind(errors,DOM)


###  relative difference between expected cv and cv threshold  ###

difrel_cvref=(cv_eta-param1$cvt_err)/param1$cvt_err  
colnames(difrel_cvref)<-c(paste("difrel",1:(param$domvar),sep=""))

###  difference >0 variable  ###

pos<-matrix(,1,param$domvar)
for(j in 1:param$domvar) {
   pos[,j]<-0      }
pos<-as.vector(pos)
for(j in 1:param$domvar) {
   if (difrel_cvref[j]>0) {pos[j]<-difrel_cvref[j]}}

###  difference >0 variable indicator  ###

n_pos<-matrix(,1,param$domvar)
for(j in 1:param$domvar) {
   n_pos[,j]<-0      }
n_pos<-as.vector(n_pos)
for(j in 1:param$domvar) {
   if (pos[j]>0) {n_pos[j]<-1}}

###   difference >1% variable  ###

n_pos1<-matrix(,1,param$domvar)
for(j in 1:param$domvar) {
   n_pos1[,j]<-0      }
n_pos1<-as.vector(n_pos1)
for(j in 1:param$domvar) {
   if (pos[j]>0.01) {n_pos1[j]<-1}}
   


n_pos<-sum(n_pos)     ###   number of difference >0    ###
n_pos1<-sum(n_pos1)   ###   number of difference >1%   ###

try(t_max<-t(difrel_cvref))  ### try
jj<-0

try(for(j in 1:param$domvar) {
   if (t_max[j,]>0) {jj<-jj+1}})  ### try

try(tt_max<-matrix(,jj),TRUE) ### try

jj<-0

try(for(j in 1:param$domvar) {
   if (t_max[j,]>0) {jj<-jj+1
       tt_max[jj]<-t_max[j]}}) ### try

######   crea  matrix cv_hist  (una riga per ogni iterazione)    ######
     

cv_hist_cv   <- vector(mode="numeric")
cv_hist_stat <- vector(mode="numeric")
cv_hist_cons <- vector(mode="numeric")


cv_expected[inn,1]<-out  
cv_expected[inn,2]<-inn
cv_expected[inn,3]<-camp
cv_expected[inn,4:(param$domvar+3)]<-cv_eta

constraint[inn,1]<-out  
constraint[inn,2]<-inn
constraint[inn,3]<-camp
constraint[inn,4:(param$domvar+3)]<-cv


stat[inn,1]<-out  
stat[inn,2]<-inn
stat[inn,3]<-camp
stat[inn,4]<-camp-camp_prec
stat[inn,5]<-n_pos
stat[inn,6]<-n_pos1
try(stat[inn,7]<-mean(tt_max),TRUE)
try(stat[inn,8]<-median(tt_max),TRUE)
try(stat[inn,9]<-quantile(tt_max,prob=.75),TRUE)
try(stat[inn,10]<-max(tt_max),TRUE)

}

      
      hist_constraints   <- rbind(hist_constraints , constraint)
hist_expected_cv   <- rbind(hist_expected_cv, cv_expected)
hist_stat          <- rbind(hist_stat , stat)



if (sum(probabil)-sum(prob_1)<convergence)
break;

output$var<-prob_1
colnames(output)[ncol(output)]<-paste("size_out",out+1,sep="") 

a<-c(paste("size_out",out+1,sep=""))
b<-c(param$pop)
aa<- subset(output,select=a)
bb<- subset(output,select=b)
inc.prob<-aa/bb
colnames(inc.prob)<-c(paste("INC.PROB",out+1,sep=""))
output<-cbind(output, inc.prob)
}


mw_convergence<-cbind(maxiter, convergence)



nomi_cv_exp<-matrix(,1,3) 
colnames(nomi_cv_exp)<-c("out_iter","in_iter","sample")
for (v in 1:param$vars)
{for (m in 1:param$nmarg)
{z<-param$dim_dom[,m]
             ex1    <-matrix(,1,z)  
             colnames (ex1)<-(paste("cv_eta",".",v,".",m,":",1:z,sep=""))
 nomi_cv_exp <-cbind (nomi_cv_exp, ex1)             
            }
      }

colnames(hist_expected_cv)<-colnames(nomi_cv_exp)

output_mw<-list(output=output,errors=errors, 
hist_constraints= hist_constraints, hist_expected_cv=hist_expected_cv, 
hist_stat=hist_stat, 
convergence=mw_convergence) 



return (invisible(output_mw))


}
