\name{graduates}
\alias{graduates}
\docType{data}
\title{Graduates}
\description{
Sub-population of the 2007 Italian graduates (Master Degree). 
Each observation is a profile. A profile  identifies a set of graduates with the same values
 of the YPRED variables and MARG variables (see \link{parameters} function).   The total number of graduates is 3427. 
}
\usage{data (graduates)}
\format{
  A data frame with 1679 observations on the following 10 variables.
  \describe{
    \item{\code{y1}}{working probability of graduates in the profile}
    \item{\code{y2}}{looking for a job probability of graduates in the profile}
    \item{\code{dom1}}{code identifying the domain of the first partition (margin). Factor with levels \code{1} \code{2} \code{3} \code{4} \code{5} \code{6} \code{7} \code{8} \code{9} \code{10} \code{11} \code{12} \code{13} \code{14} \code{15} \code{16} \code{17} \code{18} \code{19} \code{20}}
    \item{\code{dom2}}{code identifying the domain of the second partition (margin). Factor with levels \code{1} \code{2} \code{3} \code{4} \code{5} \code{6} \code{7} \code{8} \code{9} \code{10} \code{11} \code{12} \code{13} \code{14} \code{15}}
    \item{\code{vary1}}{model variance of y1}
    \item{\code{vary2}}{model variance of y2}
    \item{\code{id_rek}}{code identifying the 1679 profiles}
    \item{\code{prof.size}}{number of graduates in the profile}
    \item{\code{start.allocation}}{starting sample size in the profile}
  }
}
      

\details{The sample alloction algorithm assumes the driving variables are unknown and predicted by a 
super population model (Sarndal \emph{et al.}, 1992). 
The values of the variables vary1 and vary2 give the model uncertanty of the predicted values according to 
expression (4.1) in Falorsi and Righi (2015).

Note, the variables dom1, dom2 and id_rek can be  numeric as well.

}


\source{Italian National Statistical Institute}

\references{Falorsi, P.D. and Righi P.(2015). Generalized framework for defining the optimal inclusion probabilities 
 of one-stage sampling designs for multivariate and multi-domain surveys, \emph{Survey Methodology}, 41, n.1, 215-236.

Sarndal, C.E., Swensson, B., and Wretman, J. (1992). \emph{Model Assisted Survey Sampling}.
New York: Springer-Verlag.
}

\examples{
data(graduates)
head(graduates)
}

