\name{ict.enterprises}
\alias{ict.enterprises}
\docType{data}
\title{Enterprises in Computer and related economic activities }
\description{Italian Enterprises from 1 to 99 employees (year 1999) belonging to the 
Computer and related economic activities (2-digits of the NACE rev.1 classification) - Information and Communication Technology (ICT).  
Several domain partitions (margins) are taken into account.  
Each observation is a profile. A profile  identifies a set of enterprises with the same values
 of the YPRED variables and MARG variables (see \link{parameters} function). The total number of enterprises is 10329. 
}

\usage{data(ict.enterprises)}
\format{
  A data frame with 1867 observations on the following 13 variables.
  \describe{
    \item{\code{STRATO}}{code identifying the record}
    \item{\code{N}}{number of enterprises in the profile}
    \item{\code{initial.size}}{starting sample size in the profile}
    \item{\code{M1}}{predicted labour cost}
    \item{\code{M2}}{predicted value added}
    \item{\code{V1}}{model variance of ypred1}
    \item{\code{V2}}{model variance of ypred2}
    \item{\code{DOM1}}{Country (1 domain)}
    \item{\code{DOM2}}{geographical region (20 domains)}
    \item{\code{DOM3}}{economic activity group (6 groups) by Size class, number of persons employed 1-4; 5-9; 10-19;20-99 (24 domains)}
    \item{\code{w1}}{economic activity group (6 domains)}
    \item{\code{w2}}{size class, number of persons employed 1-4; 5-9; 10-19;20-99 (4 domains)}    
    \item{\code{w3}}{geographical region (20 domains)}
    }
}
\details{The sample alloction algorithm assumes the driving variables are unknown and predicted by the values in M1 and M2 according to a 
super population model (Sarndal \emph{et al.}, 1992). 
The values of the variables V1 and V2 give the model uncertanty (model variances) of the predicted values according to 
expression (4.1) in Falorsi and Righi (2015).

In the example the starting sample size is fixed to 0.99 by N for all the population units.
The optimal solution is not affected by the starting sample size but the number of loops can change.  

If the records of the data frame were the singol enterprises then N=1. Furthermore, the starting sample size should be the starting inclusion probability.

The data frame contains two sets of partitions: DOM1, DOM2, DOM3; w1,w2,w3. Application can consider only one set of partition.
}
\source{Based on data of Italian National Statistical Institute.}

\references{

Falorsi, P.D. and Righi P.(2015). Generalized framework for defining the optimal inclusion probabilities 
 of one-stage sampling designs for multivariate and multi-domain surveys, \emph{Survey Methodology}, 41, n.1, 215-236.

Falorsi, P.D. and Righi P.(2008). A balanced sampling approach for multi-way stratification
designs for small area estimation, \emph{Survey Methodology}, 34, n.2, 223-234.

Sarndal, C.E., Swensson, B., and Wretman, J. (1992). \emph{Model Assisted Survey Sampling}.
New York: Springer-Verlag.
}
\examples{
data(ict.enterprises)
head(ict.enterprises)
## maybe str(ict.enterprises) ; plot(ict.enterprises) ...
}
\keyword{datasets}




